'defdbl a - z  'seems to make no difference to speed, remove for space in PB
cls
dim huge dat(16384) , dispdat(16383)
'dim huge dat(4096) , dispdat(4096)

dbscale = 80
dboffset = 20
colfact = 16
wintype% = 1
pi = 3.141592653589793238462643383279
comport$ = environ$("DSPCOM")
if comport$ = "" then
	sound 400 , 2
	print "Environment variable DSPCOM not set   eg. DSPCOM=2"
	end
end if
screen 12
cmd$ = ucase$(command$)
if instr(cmd$ , "MON") > 0 then call GreyPalette
if instr(cmd$ , "QUICK") > 0 then quickstart% = -1
def seg = &h40
comaddr% = peeki(2 * val(comport$) - 2)
out comaddr% + 4 , 3         'set DTR and RTS for interface
locate 5 , 15 : color 14
print "Serial A/D converter spectrum analyser display"
color 10 : locate 10 , 30
print "Setting interface...."
locate 30 , 25
print "Interface on COM";comport$;"  Address ";hex$(comaddr%);
delay 1 'Allow interface to settle
locate 12 , 30
print "Adjust input level..."

if not quickstart% then CheckLevel
nsamples% = 512
locate 18 , 10
color 15 : print "Sampling rate  Hz";
color 12 : print tab(30);"1 "; : color 7 : print "  10000 Hz   100 us";
color 12 : print tab(30);"2 "; : color 7 : print "   7143 Hz   140 us";
color 12 : print tab(30);"3 "; : color 7 : print "   2500 Hz   400 us";
color 12 : print tab(30);"4 "; : color 7 : print "   1000 Hz  1000 us";

while not instat : wend
a$ = ucase$(inkey$)
select case a$
case "4"
	BaseSampleRate = 1000
case "2"
	BaseSampleRate = 1e6 / 140
case "3"
	BaseSampleRate = 2500
case "1" , chr$(13)
	BaseSampleRate = 10000
case else
	sound 400 , 1
	end
end select
locate 24 , 15
input "Decimation factor      (1)     ",decim%
if decim% = 0 then decim% = 1
samplerate =  BaseSampleRate / decim%
locate 25 , 15
input "Spectrum Averaging     (2)     ",avno%
if avno% = 0 then avno% = 2
locate 26 , 15
print "Log scale   Y / n"
while not instat : wend
if ucase$(inkey$) <>"N" then lg% = -1 else lg% = 0
cls
gosub DoAction       'to set initial screen
on error goto errhndlr

do
   tim = timer       'to time rest of functions
	for av% = 1 to avno%
		call ReadAdc (nsamples%)
		locate 5 , 60
		if ivar% then
			color 12
			sound 2000 , .054
		else
			color 10
		end if

		select case wintype%
		case 1
			call HammingWind(nsamples%)
		case 2
			call BlackHarrisWind(nsamples%)
		end select
		call FFT (nsamples% , 1)
		for k% = 1 to nsamples% step 2
			dispdat(k% \ 2)  = dat(k% - 1) ^ 2  + dat(k%)^ 2 + dispdat(k% \ 2)
		next k%
	next av%
	cls graphics
	call DrawScale
	color 15
	locate 1,60
	print using "Sample rate  ##### Hz";samplerate;
	locate 2,60
	print using "#### Bins   ###.## Hz";nsamples% / 2 , samplerate / nsamples%;
		locate 3 , 60
	select case wintype%
	case 0
		print "No window           "
	case 1
		print "Hamming window      "
	case 2
		print "Black. Harris Window"
	end select
   locate 4 , 60
	print using "Average over ###";avno%
	locate 5 , 60
	if timetaken > 1.5 then
		print using "Update rate  ##.#s";timetaken;
	else
		print space$(21);
	end if
	locate 30 , 5 : print "0";
	locate 30 , 70 : print using "##### Hz";samplerate / 2;

	for k% = 1 to nsamples% step 2     'half way through array only
		mag = sqr(dispdat(k% \ 2) / avno%)
		dispdat(k% \ 2) = 0
		if lg% then
			db = 10 * (log10((mag + 1) / nsamples%)) + dboffset
			if mag < 5 then db = 0
			mag = db * nsamples% * 64 / dbscale
		end if
		if plbase% then
			line (k% , 0) - (k% , mag) , 14
		else
			line (k% - 2 , lastm) - (k% , mag) , 14
			lastm = mag
		end if
	next k%
	if instat then gosub DoAction
   samplerate = BaseSampleRate / decim%
	tim = timer - tim
	timetaken = tim
loop
end
'========================================================================
sub ReadAdc (n%)
	shared decim% , comport$, comaddr% , dat()
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1 , dt , ds, cs , cd , me , fe" as 1 len = 30000
	for samplecount% = 1 to 2 * n% - 1 step 2
		for decimcount% = 1 to decim%
			do until loc(1) > 0
			loop
			a$ = input$(loc(1) , 1)
			value% = asc(a$) - 128
			if decimcount% = 1 then
				dat(samplecount%) = value%
				dat(samplecount% + 1) = 0
			else
				dat(samplecount%) = value% / decim% + dat(samplecount%)
				dat(samplecount% + 1) = 0
			end if
		next decimcount%
	next samplecount%
	close 1
	out comaddr% + 4 , 3
end sub
'========================================================================

sub FFT(nn% , isign%)          'isign% = 1 for FFT,  -1 for INV FFT
'data format  (re,im,re,im,....) starting at 1
	shared pi , dat()
	n% = 2 * nn%
	j% = 1
	for i% = 1 to n% step 2
		if j% > i% then
			swap dat(i%) , dat(j%)
			swap dat(i% + 1) , dat(j% + 1)
		end if
		m% = n% \ 2
		while m% >= 2 and j% > m%
			decr j% , m%
			shift right m% , 1            ' /2
		wend
		incr j% , m%
	next i%
	mmax% = 2

	while n% > mmax%
		istep% = 2 * mmax%
		theta = 2 * pi / (isign% * mmax%)
		wpr = cos(theta)
		wpi = sin(theta)
		wr = 1
		wi = 0
		for m% = 1 to mmax% step 2
			for i% = m% to n% step istep%
				j% = i% + mmax%
				tempr = wr * dat(j%) - wi * dat(j% + 1)
				tempi = wr * dat(j% + 1) + wi * dat(j%)
				dat(j%) = dat(i%) - tempr
				dat(j% + 1) = dat(i% + 1) - tempi
				incr dat(i%) , tempr
				incr dat(i% + 1) , tempi
			next i%
			wtemp = wr
			wr = wr * wpr - wi * wpi
			wi = wi * wpr + wtemp * wpi
		next m%
		mmax% = istep%
	wend


end sub
'================================================================================

sub DrawScale
	shared lg% , nsamples% , samplerate , dboffset , dbscale
	colgrid% = 7
	color 3
	maxheight = nsamples% * 64
	line (nsamples% , 0) - (1 , 0) , colgrid%
	line - (1 , maxheight) , colgrid%
	locate 29 , 38
	if samplerate <= 2000 then
		plint% = 10
		hi% = 100
		print "100 Hz ";
	else
		plint% = 100
		hi% = 1000
		print "1000 Hz"
	end if
	for freq = plint% to samplerate / 2 step plint%
		if freq mod hi% = 0 then patt% = &hFFFF else patt% = &hF0F0
		xposn% = freq / samplerate * 2 * nsamples%
		line (xposn% , 0) - (xposn% , maxheight) , colgrid% ,, patt%
	next freq
	if lg% then
		for db% = 0 to dbscale step 2
			y = (db% - 0) * nsamples% * 64 / dbscale
			if db% mod 10 = 0 then
				patt% = &hFFFF
			else
				patt% = &hF0F0
			end if
			line (0 , y) - (nsamples% , y) , colgrid% ,, patt%
		next db%
		locate 15 , 1 : print " 10dB ";
	else
		locate 15 , 1 : print "Linear"
	end if
end sub
'================================================================

sub HammingWind (n%)
	shared pi , dat()
	for k% = 0 to n% - 1
		locdat% = k% * 2 + 1
		dat(locdat%) = dat(locdat%) * (1 - .851852 * cos(2 * pi * k%/ n%))
		dat(locdat% + 1) = dat(locdat% + 1) * (1 - .851852 * cos(2 * pi * k%/ n%))

	next k%
end sub

sub BlackHarrisWind (n%)
	shared pi , dat()
	for k% = 0 to n% - 1
   	locdat% = k% * 2 + 1
		theta = 2 * pi * k% / n%
		dat(locdat%) = dat(locdat%) * (.42323 - .49755 * cos(theta)_
											 + .07922 * cos(2 * theta)) / .42
		dat(locdat% + 1) = dat(locdat% + 1) * (.42323 - .49755 * cos(theta)_
											 + .07922 * cos(2 * theta)) / .42

	next k%
end sub
'=================================================================
sub CheckLevel
	shared comport$, comaddr%, dat()
	close 1   'since probably already open
	for t% = 0 to 4095
		dat(t%) = 0
	next t%
	out comaddr% + 4 , 3
	open "com" + comport$ + ": 115200 , n , 8, 1, ds, cs , cd , me , fe" as 1 len = 30000
	line (191 , 230) - (191 , 254) , 10
	line (449 , 230) - (449 , 254) , 10
	do
		do until loc(1) > 0
			if instat then ik$ = inkey$
		loop
      if ik$ = chr$(27) then end
		a$ = input$(loc(1) , 1)
		value% =  abs(asc(a$) - 128)
		if value% > 126 then co% = 12 else co% = 11
		line (192 , 240) - (448 , 243) , 0 , bf
		line (320 - value% , 240) - (320 + value% , 243) , co% , bf
		if instat then ik$ = inkey$
	loop until ik$ > ""
	close 1
   out comaddr% + 4 , 3
end sub
'=========================================================================
sub GreyPalette
	for co% = 0 to 15
		palette co% , co%
		rgb% = co% * 4 + 3
		reg 1 , &h1010
		reg 2 , co%
		reg 3 , 256 * rgb% + rgb%
		reg 4 , rgb% * 256
		call interrupt &h10
	next co%
end sub

sub ShowCols
	for co% = 0 to 15
		locate 20 - co% , 80
		color co%
		print "";
	next co%
end sub

sub MakeBmp(basename$)       'Palette table assumes EGA compatibility
	filename$ = dir$(basename$ + "???.bmp")
	n% = val(mid$(filename$ , 6, 3))
	do
		f$ = dir$
		n% = max(val(mid$(f$ , 6, 3)) , n%)
	loop until f$ = ""
	n$ = mid$(str$(min(n% + 1, 999)) , 2)
	do while len(n$) < 3
		n$ = "0" + n$
	loop
	f$ = basename$ + n$ + ".BMP"
	locate 5 , 1
	print using "\             \     ";f$
	bwidth& = 640           'previously set by   PALETTE CO%,CO%
	bheight& = 480
	ColoursInTable& = 16
	BitsPerPixel% = 4        '1 / 4 / 8 / 24  only
	NPlanes% = 1             '1 only
	InfoSize& = 40

	ImageSize& = bwidth& * bheight& * BitsperPixel% / 8
	dataoffset& = 54 + ColoursInTable& * 4
	filesize& = dataoffset& + ImageSize&

	t = timer
	if instr(ucase$(f$) , ".BMP") = 0 then f$ = f$ + ".BMP"
	fi% = freefile
	open "b" , fi% , f$
	i1% = 0 : i2% = 0 : compression& = 0
	bm$ = "BM"
	put$ fi% , bm$
	put fi% , 2 , filesize&
	put fi% ,, i1%
	put fi% ,, i2%
	put fi% ,, DataOffset&
	put fi% ,, InfoSize&
	put fi% ,, bwidth&
	put fi% ,, bheight&
	put fi% ,, NPlanes%
	put fi% ,, BitsPerPixel%
	put fi% ,, compression&
	put fi% ,, ImageSize&
	put fi% ,, XPelsPerMetre&
	put fi% ,, YPelsPerMetre&
	put fi% ,, ColoursInTable&
	put fi% ,, ImportantColours&

	seek fi% , 54
	for rgb% = 0 to 15
		reg 1 , &h1015
		reg 2 , rgb%
		call interrupt &h10
		b% = (reg(3) mod 256) * 4
		g% = (reg(3) \ 256) * 4
		r% = (reg(4) \ 256) * 4
		pa$ = chr$(b%) + chr$(g%) + chr$(r%) + chr$(0)
		put$ fi% , pa$
	next rgb%

	seek fi% , dataoffset&         'data starts at bottom left of picture
	nibble% = 0
	for y% = bheight& - 1 to 0 step -1
		dat$ = ""
		for x% = 0 to bwidth& - 2 step 2
				d% = 16 * point (x% , y%) + point (x% + 1 , y%)
				dat$ = dat$ + chr$(d%)
		next x%
      put$ fi% , dat$
	next y%
	close fi%
	sound 1750 , 2
end sub
'===========================================================================
DoAction:
	select case ucase$(inkey$)
	case chr$(27)
		end
	case "+"
		nsamples% = min (nsamples% * 2 , 8192)
		newwind% = -1
	case "-"
		nsamples% = max (nsamples% / 2 ,8)
		newwind% = -1
	case "G"
		lg% = -1 - lg%
		for li% = 5 to 30
			locate li% , 6
			print "   ";
		next li%
	case "W"
		incr wintype%
		wintype% = wintype% mod 3
	case "L"
		plbase% = not plbase%
	case "D"
		decim% = decim% + 1
		clscn% = -1
	case chr$(4)
		decim% = max(decim% -1 , 1)
		clscn% = -1
	case "B"
		dboffset = dboffset + 5
	case chr$(2)
		dboffset = dboffset - 5
	case "S"
		dbscale = dbscale * 1.05
	case chr$(19)
		dbscale = dbscale / 1.05
	case "R"
		clscn% = -1
	case "K"
		window
		CheckLevel
		newwind% = -1
	case "M"
		call GreyPalette
	case "C"
		colfact = colfact * 1.2
	case chr$(3)
		colfact = colfact / 1.2
	case "V"
		if avno% < 4 then incr avno% else avno% = 2 * avno%
	case chr$(22)
		if avno% < 4 then avno% = max(avno% - 1 , 1) else avno% = avno% / 2
	case chr$(0 , 59)
		window
		view
		call MakeBmp("SPDSP")
	end select

	window (0 , 0) - (nsamples% , nsamples% * 32)
	view (64 , 80) - (575 , 447)
	color 11
	locate 1 , 1 : print "+ / -      No of bins          L            Plot style
	locate 2 , 1 : print "D / ctl-D  Decimation          G            Lin / Log"
	locate 3 , 1 : print "W          Window type         B / ctl-B    Log baseline"
	locate 4 , 1 : print "V / ctl-V  Averaging           S / ctl-S    Log scale
	locate 5 , 1 : print "F1         .BMP File"

	clscn% = 0
	newwind% = 0
return

errhndlr:
	resume next
